#!/usr/bin/env python
#-*- coding: utf-8 -*-
# Copyright (c) 2000-2019 Synology Inc. All rights reserved.

from os import environ
import imp

common = imp.load_source('common', '/var/packages/Chat/target/bin/sdk_plugin/common.py')

class AppPrivilegeSet(common.Runner):
	def __init__ (self):
		common.Runner.__init__(self)
		self.privilegeChangedUsers = []
		self.privilegeChangedData = {
			'should_refresh': False
		}

	# @override
	def post (self):
		if environ.get('RESULT') != '0':
			return None

		items = int(environ.get('NITEM'))
		for i in range(1, items + 1):
			appName            = environ.get('APP_' + str(i))
			privilegeType      = environ.get('TYPE_' + str(i))
			privilegeId        = environ.get('ID_' + str(i))

			if appName == 'SYNO.SDS.Chat.Application':
				if privilegeType == 'USER':
					self.privilegeChangedUsers.append({
						'uid': privilegeId
					})

				if privilegeType == 'GROUP':
					self.privilegeChangedData = {
						'should_refresh': True
					}

				# Type 'EVERYONE' can be tiggered by check/ uncheck below checkbox in control panel
				# Privilege -> App -> Default privileges -> Grant this privilege to all users by default
				if privilegeType == 'EVERYONE':
					self.privilegeChangedData = {
						'should_refresh': True
					}

		if len(self.privilegeChangedUsers) > 0:
			common.callChatHook('user_privilege_change', self.privilegeChangedUsers)

		if self.privilegeChangedData['should_refresh']:
			common.callChatHook('user_privilege_refresh', self.privilegeChangedData)

common.Main(AppPrivilegeSet())
