#!/usr/bin/env python
#-*- coding: utf-8 -*-

from os import environ
import imp

common = imp.load_source('common', '/var/packages/Chat/target/bin/sdk_plugin/common.py')

class ShareSet(common.Runner):
	def __init__ (self):
		common.Runner.__init__(self)
		self.version = '2.0'

	def isMe (self):
		return environ.get('SHARE_NAME') == 'chat'

	def isShareEncryptChanged (self):
		return environ.get('ORIGIN_SHARE_ENCRYPTION') != environ.get('SHARE_ENCRYPTION');

	def isShareForbiddenChanged (self):
		return environ.get('ORIGIN_SHARE_FORBIDDEN') != environ.get('SHARE_FORBIDDEN');

	# @override
	def pre (self):
		if not self.isMe():
			return None

		if self.isShareEncryptChanged() and environ.get('SHARE_ENCRYPTION') == 'encrypted':
			self.stopPackage('chat share is unmounted')
		elif self.isShareForbiddenChanged() and environ.get('SHARE_FORBIDDEN') == '1':
			self.stopPackage('chat share is currently unavailable')

common.Main(ShareSet())