#!/usr/bin/env python
#-*- coding: utf-8 -*-
# Copyright (c) 2000-2016 Synology Inc. All rights reserved.

from os import environ
import imp

common = imp.load_source('common', '/var/packages/Chat/target/bin/sdk_plugin/common.py')

class UserSet(common.Runner):
	def __init__ (self):
		common.Runner.__init__(self)
		# self.expireChangedUsers = []
		self.renamedUsers = []
		self.modifiedUsers = []

	# @override
	def post (self):
		if '0' != environ.get('RESULT'):
			return None

		items = int(environ.get('NITEMS'))
		for i in range(1, items + 1):
			uid            = environ.get('UID_' + str(i))
			userName       = environ.get('USER_NAME_' + str(i))
			originUserName = environ.get('ORIGIN_USER_NAME_' + str(i))
			expireState    = environ.get('EXPIRE_STATE_' + str(i))
			result         = environ.get('USER_OP_RESULT_' + str(i))

			self.modifiedUsers.append({
				'uid': uid
			})

			if userName != originUserName and originUserName != None:
				self.renamedUsers.append({
					'uid': uid,
					'username': userName,
					'origin_username': originUserName
				})

		self.formOutput()

	def formOutput (self):
		if len(self.modifiedUsers) > 0:
			time.sleep(10)
			common.callChatHook('user_privilege_change', self.modifiedUsers)

		if len(self.renamedUsers) > 0:
			common.callChatHook('user_rename', self.renamedUsers)
common.Main(UserSet())
