CREATE VIEW view_channel_members_human AS
	SELECT CM.*, H.status AS human_status
	FROM channel_members AS CM
	JOIN human AS H ON CM.user_id = H.id;
ALTER TABLE channels ADD COLUMN encrypted bool NOT NULL DEFAULT false;
ALTER TABLE channels ADD COLUMN props json;
ALTER TABLE posts ADD COLUMN props json;
CREATE INDEX channels_encrypted_key ON channels (encrypted);
ALTER TABLE channels DROP CONSTRAINT channels_members_key;
CREATE UNIQUE INDEX channels_encrypted_members_key ON channels (encrypted, members);
ALTER TABLE channels ALTER COLUMN creator_id TYPE int;
INSERT INTO configs (key, value) VALUES ('db_uuid', md5(random()::text || clock_timestamp()::text)::uuid::text);
CREATE TABLE logs (
	id                   serial          NOT NULL PRIMARY KEY,
	username             text            NOT NULL,
	type                 int             NOT NULL,
	operation            text            NOT NULL,
	props                json,
	create_at            bigint          NOT NULL DEFAULT get_time_ms()
);
CREATE INDEX logs_username_key ON logs (username);
CREATE INDEX logs_type_key ON logs (type);
CREATE INDEX logs_create_at_key ON logs (create_at);
