CREATE TABLE webhook_broadcast (
) INHERITS (bots);
CREATE UNIQUE INDEX webhook_broadcast_id_key ON webhook_broadcast(id);
ALTER TABLE webhook_broadcast ADD PRIMARY KEY USING INDEX webhook_broadcast_id_key;
CREATE INDEX webhook_broadcast_updateat_key ON webhook_broadcast (update_at);
CREATE INDEX webhook_broadcast_deleteat_key ON webhook_broadcast (delete_at);
CREATE UNIQUE INDEX webhook_broadcast_token_key ON webhook_broadcast (token);
CREATE TRIGGER webhook_broadcast_update_trigger BEFORE UPDATE ON webhook_broadcast FOR EACH ROW EXECUTE PROCEDURE updateat_trigger();
CREATE TRIGGER webhook_broadcast_delete_trigger BEFORE DELETE ON webhook_broadcast FOR EACH ROW EXECUTE PROCEDURE user_delete_trigger();
CREATE INDEX webhook_broadcast_browse_key ON webhook_broadcast (create_at,delete_at);
CREATE INDEX webhook_broadcast_sticker_id_key ON webhook_broadcast (sticker_id);
CREATE INDEX webhook_broadcast_creator_id_key ON webhook_broadcast (creator_id);
CREATE TABLE apps (
			id                    serial         NOT NULL PRIMARY KEY,
			token                 text           UNIQUE NOT NULL,
			name                  text           UNIQUE NOT NULL,
			props                 json,
			is_package            boolean        NOT NULL DEFAULT false,
			create_at             bigint         NOT NULL DEFAULT get_time_ms(),
			update_at             bigint,
			delete_at             bigint
);
CREATE INDEX apps_createat_key ON apps (create_at);
CREATE INDEX apps_updateat_key ON apps (update_at);
CREATE INDEX apps_deleteat_key ON apps (delete_at);
CREATE INDEX apps_ispackage_key ON apps (is_package);
CREATE INDEX apps_name ON apps (name);
ALTER TABLE bots ADD COLUMN app_id int;
CREATE INDEX bots_appid_key on bots (app_id);
CREATE INDEX webhook_incoming_appid_key on webhook_incoming (app_id);
CREATE INDEX webhook_outgoing_appid_key on webhook_outgoing (app_id);
CREATE INDEX webhook_broadcast_appid_key on webhook_broadcast (app_id);
DROP VIEW view_webhook_incoming_channels;
CREATE VIEW view_webhook_incoming_channels AS
	SELECT WI.*, C.type AS channel_type
	FROM webhook_incoming AS WI
	LEFT JOIN channels AS C ON WI.channel_id = C.id;
DROP VIEW view_webhook_outgoing_channels;
CREATE VIEW view_webhook_outgoing_channels AS
	SELECT WO.*, C.type AS channel_type
	FROM webhook_outgoing AS WO
	LEFT JOIN channels AS C ON WO.channel_id = C.id;
