CREATE TABLE webhook_slash (
	cmd            text     UNIQUE,
	slash_props    json
) INHERITS (bots);
CREATE UNIQUE INDEX webhook_slash_id_key ON webhook_slash(id);
ALTER TABLE webhook_slash ADD PRIMARY KEY USING INDEX webhook_slash_id_key;
CREATE INDEX webhook_slash_updateat_key ON webhook_slash (update_at);
CREATE INDEX webhook_slash_deleteat_key ON webhook_slash (delete_at);
CREATE INDEX webhook_slash_type_key ON webhook_slash (type);
CREATE INDEX webhook_slash_sub_type_key ON webhook_slash (sub_type);
CREATE UNIQUE INDEX webhook_slash_token_key ON webhook_slash (token);
CREATE TRIGGER webhook_slash_update_trigger BEFORE UPDATE ON webhook_slash FOR EACH ROW EXECUTE PROCEDURE updateat_trigger();
CREATE TRIGGER webhook_slash_delete_trigger BEFORE DELETE ON webhook_slash FOR EACH ROW EXECUTE PROCEDURE user_delete_trigger();
CREATE INDEX webhook_slash_browse_key ON webhook_slash (create_at,delete_at);
CREATE INDEX webhook_slash_creator_id_key ON webhook_slash (creator_id);