CREATE OR REPLACE FUNCTION channel_member_recover_check_close() RETURNS trigger AS $$
DECLARE
	is_closed boolean;
BEGIN
    IF OLD.delete_at IS NOT NULL AND NEW.delete_at IS NULL THEN
		SELECT close_at IS NOT NULL INTO is_closed FROM channels WHERE id = NEW.channel_id;
        IF is_closed = true THEN
            RAISE EXCEPTION 'channel is already closed %', NEW.channel_id;
        END IF;
	END IF;
	RETURN NEW;
END;
$$ LANGUAGE plpgsql;
CREATE TRIGGER channel_members_update2 BEFORE UPDATE ON channel_members FOR EACH ROW EXECUTE PROCEDURE channel_member_recover_check_close();
CREATE OR REPLACE FUNCTION channel_member_insert_check_close() RETURNS trigger AS $$
DECLARE
	is_closed boolean;
BEGIN
    SELECT close_at IS NOT NULL INTO is_closed FROM channels WHERE id = NEW.channel_id;
    IF is_closed = true THEN
        RAISE EXCEPTION 'channel is already closed %', NEW.channel_id;
    END IF;
	RETURN NEW;
END;
$$ LANGUAGE plpgsql;
CREATE TRIGGER channel_members_insert BEFORE INSERT ON channel_members FOR EACH ROW EXECUTE PROCEDURE channel_member_insert_check_close();
