DROP INDEX channels_encrypted_members_key;
CREATE UNIQUE INDEX channels_encrypted_members_key ON channels (encrypted, members) WHERE close_at IS NULL;
UPDATE channels
SET members = subquery.members
FROM (
	SELECT c.id AS channel_id, array_to_string(array_agg(cm.user_id ORDER BY cm.user_id), ',') AS members
	FROM channel_members cm JOIN channels c ON cm.channel_id = c.id
	WHERE c.type = 2 AND c.close_at IS NOT NULL
	GROUP BY c.id
) AS subquery
WHERE subquery.channel_id = channels.id;
DROP INDEX users_dsm_username_key;
CREATE INDEX users_dsm_username_key ON users_dsm (username) WHERE delete_at IS NULL;
UPDATE users_dsm SET username = display_username WHERE username IS NULL;
ALTER TABLE users_dsm DROP COLUMN display_username;
DROP TRIGGER users_dsm_update_trigger2 ON users_dsm;
DROP FUNCTION user_update_trigger();
CREATE OR REPLACE FUNCTION "json_object_update_key"(
  "json"          json,
  "key_to_set"    TEXT,
  "value_to_set"  anyelement
)
  RETURNS json
  LANGUAGE sql
  IMMUTABLE
  STRICT
AS $function$
SELECT CASE
  WHEN ("json" -> "key_to_set") IS NULL THEN "json"
  ELSE (SELECT concat('{', string_agg(to_json("key") || ':' || "value", ','), '}')
          FROM (SELECT *
                  FROM json_each("json")
                 WHERE "key" <> "key_to_set"
                 UNION ALL
                SELECT "key_to_set", to_json("value_to_set")) AS "fields")::json
END
$function$;
UPDATE channel_members SET props = json_object_update_key(props, 'notification_desktop', 'mention_subscribe'::text) WHERE props->>'notification_desktop' = 'mention' AND id IN
(SELECT CM.id FROM channel_members AS CM LEFT JOIN channels AS C ON CM.channel_id = C.id WHERE C.type in (0, 1));
UPDATE channel_members SET props = json_object_update_key(props, 'notification_mobile', 'mention_subscribe'::text) WHERE props->>'notification_mobile' = 'mention' AND id IN
(SELECT CM.id FROM channel_members AS CM LEFT JOIN channels AS C ON CM.channel_id = C.id WHERE C.type in (0, 1));
