CREATE TABLE if not exists post_unread (
	post_id				BIGINT	PRIMARY KEY REFERENCES posts(id) ON DELETE CASCADE ON UPDATE CASCADE,
	create_user_id		INT		NOT NULL,
	channel_id			INT		NOT NULL REFERENCES channels(id) ON DELETE CASCADE ON UPDATE CASCADE,
	post_at				bigint	not null,
	thread_id			BIGINT,
	is_comment			boolean DEFAULT false,
	mentions			integer[],
	unread_user_list	integer[],
	extra_info          TEXT	DEFAULT '{}'
);
CREATE INDEX post_unread_mentions_index on "post_unread" USING GIN ("mentions");
CREATE INDEX post_unread_unread_user_list on "post_unread" USING GIN ("unread_user_list");
CREATE INDEX post_unread_channel_id on "post_unread" ("channel_id");
ALTER TABLE user_reminders DROP CONSTRAINT IF EXISTS user_reminders_post_id_fkey;
ALTER TABLE user_reminders ADD CONSTRAINT user_reminders_post_id_fkey FOREIGN KEY (post_id) REFERENCES posts(id) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE user_stars DROP CONSTRAINT IF EXISTS user_stars_post_id_fkey;
ALTER TABLE user_stars ADD CONSTRAINT user_stars_post_id_fkey FOREIGN KEY (post_id) REFERENCES posts(id) ON DELETE CASCADE ON UPDATE CASCADE;
CREATE TABLE if not exists background_job (
    job_id              serial  NOT NULL PRIMARY KEY,
    process_id          INT     NOT NULL,
    job_type            TEXT    NOT NULL,
    cmd_name            TEXT    NOT NULL,
    run_at              bigint  NOT NULL default get_time_ms(),
    extra_info          TEXT    DEFAULT '{}'
);
CREATE INDEX background_job_job_type ON background_job (job_type);
ALTER TABLE channels ADD column hide_global_at bigint;
CREATE INDEX channels_hide_global_at ON channels (hide_global_at);
CREATE INDEX channel_members_lasthideat_index ON channel_members (last_hide_at);
CREATE UNIQUE INDEX webhook_slash_cmd_index ON  webhook_slash(cmd) WHERE delete_at IS NULL;
ALTER table webhook_slash drop CONSTRAINT IF EXISTS webhook_slash_cmd_key;
