CREATE OR REPLACE FUNCTION "json_object_update_key"(
  "json"          json,
  "key_to_set"    TEXT,
  "value_to_set"  anyelement
)
  RETURNS json
  LANGUAGE sql
  IMMUTABLE
  STRICT
AS $function$
SELECT CASE
  WHEN ("json" -> "key_to_set") IS NULL THEN "json"
  ELSE (SELECT concat('{', string_agg(to_json("key") || ':' || "value", ','), '}')
          FROM (SELECT *
                  FROM json_each("json")
                 WHERE "key" <> "key_to_set"
                 UNION ALL
                SELECT "key_to_set", to_json("value_to_set")) AS "fields")::json
END
$function$;
UPDATE channel_members SET props = json_object_update_key(props, 'notification_desktop', 'all'::text) WHERE props->>'notification_desktop' = 'mention' AND id IN
(SELECT CM.id FROM channel_members AS CM LEFT JOIN channels AS C ON CM.channel_id = C.id WHERE C.type in (2, 3));
UPDATE channel_members SET props = json_object_update_key(props, 'notification_mobile', 'all'::text) WHERE props->>'notification_mobile' = 'mention' AND id IN
(SELECT CM.id FROM channel_members AS CM LEFT JOIN channels AS C ON CM.channel_id = C.id WHERE C.type in (2, 3));
DROP FUNCTION IF EXISTS json_object_update_key("json" json, "key_to_set" TEXT, "value_to_set" anyelement);
