CREATE OR REPLACE FUNCTION post_updateat_trigger() RETURNS TRIGGER AS $$
BEGIN
	IF NEW.update_at IS NULL AND OLD.message != NEW.message THEN
		NEW.update_at = round(EXTRACT(EPOCH FROM now()));
	ELSIF OLD.update_at IS NOT NULL AND NEW.update_at < OLD.update_at THEN
		RAISE EXCEPTION 'cannot update older data';
	ELSE
		NEW.update_at = OLD.update_at;
	END IF;
	IF OLD.delete_at IS NULL AND NEW.delete_at IS NOT NULL
		AND OLD.thread_id IS NOT NULL AND OLD.thread_id != OLD.id THEN
		EXECUTE format('UPDATE channel_%s.posts SET comment_count = comment_count - 1 WHERE thread_id = %s AND thread_id = id', OLD.channel_id, OLD.thread_id);
	END IF;
	RETURN NEW;
END;
$$ language 'plpgsql';
ALTER TABLE webhook_outgoing ADD COLUMN trigger_word_tmp text[];
UPDATE webhook_outgoing SET trigger_word_tmp = string_to_array(trigger_word, ' ');
ALTER TABLE webhook_outgoing DROP COLUMN trigger_word;
DROP INDEX IF EXISTS webhook_outgoing_fulltext_search_key;
ALTER TABLE webhook_outgoing RENAME COLUMN trigger_word_tmp TO trigger_word;
CREATE INDEX webhook_outgoing_fulltext_search_key on webhook_outgoing USING GIN(trigger_word);
CREATE or REPLACE FUNCTION "string_to_array_simple"(
  "str" text
)
  RETURNS text[]
  LANGUAGE sql
  IMMUTABLE
  STRICT
AS $function$
SELECT string_to_array("str", '')
$function$;
