DROP TABLE users_guest;
ALTER TABLE human ADD COLUMN display_username text;
UPDATE human SET display_username = username;
ALTER TABLE human ALTER COLUMN display_username SET NOT NULL;
ALTER TABLE human ALTER COLUMN username DROP NOT NULL;
ALTER TABLE channel_members ADD COLUMN delete_at bigint;
CREATE INDEX channel_members_deleteat_key ON channel_members (delete_at);
CREATE OR REPLACE FUNCTION channel_member_update() RETURNS trigger AS $$
BEGIN
	IF OLD.delete_at IS NOT NULL AND NEW.delete_at IS NULL THEN
		UPDATE channels SET total_member_count = total_member_count + 1 WHERE id = OLD.channel_id;
	END IF;
	IF OLD.delete_at IS NULL AND NEW.delete_at IS NOT NULL THEN
		UPDATE channels SET total_member_count = total_member_count - 1 WHERE id = OLD.channel_id;
	END IF;
	RETURN NEW;
END;
$$ LANGUAGE plpgsql;
CREATE TRIGGER channel_members_update AFTER UPDATE ON channel_members FOR EACH ROW EXECUTE PROCEDURE channel_member_update();
CREATE INDEX users_dsm_sub_type_key ON users_dsm (sub_type);
CREATE OR REPLACE FUNCTION user_update_trigger() RETURNS trigger AS $$
BEGIN
	IF OLD.delete_at IS NULL AND NEW.delete_at IS NOT NULL THEN
		NEW.username = NULL;
	END IF;
	RETURN NEW;
END;
$$ LANGUAGE plpgsql;
CREATE TRIGGER users_dsm_update_trigger2 BEFORE UPDATE ON users_dsm FOR EACH ROW EXECUTE PROCEDURE user_update_trigger();
