/* Copyright (c) 2000-2017 Synology Inc. All rights reserved. */
"use strict";var room=require("../helper/room"),logger=require("../logger"),UPDATE_TIMEOUT_INTERVAL=3e4,Client=function(t,e,i){this.sock=i,this.api=e,this.service=t,this.destory_callbacks=[],this.cur_channel_id=null,this.user_id=this.sock.handshake.user_id,this.user_client=this.sock.handshake.query.client||"browser",this.is_active=!0,this.typing=null,this.integration=JSON.parse(this.sock.handshake.query.integration||null)};Client.prototype.init=function(){var t=Promise.resolve(),e=this.service.isUserOffline(this.user_id),i=this.integration&&this.service.isUserIntegrationOffline(this.integration,this.user_id);this.sock.join(room.getRoomByUser(this.user_id)),this.sock.handshake.init_channel_ids.forEach(function(t){this.sock.join(room.getRoomByOfflineChannel(t))},this),this.integration&&this.sock.join(room.getRoomByIntegration(this.integration)),this.sock.on("client.user.activate",this.onClientActivate.bind(this)),this.sock.on("client.user.deactivate",this.onClientDeactivate.bind(this)),this.sock.on("client.user.typing",this.onClientTyping.bind(this)),this.sock.on("client.user.clear_typing",this.onClientClearTyping.bind(this)),e&&(t=t.then(()=>this.updateUserStatus("online")).catch(()=>logger.error("set user status"))),(t=t.then(()=>this.sock.emit("client.init",{id:this.sock.id,version:process.env.npm_package_version}))).then(()=>{if(this.integration){var t=this.service.getIntegrationOnline(this.integration);this.sock.emit("client.integration.online",{user_ids:t}),i&&this.sock.broadcast.to(room.getRoomByIntegration(this.integration)).emit("client.integration.online",{user_ids:t})}})},Client.prototype.onClientActivate=function(){logger.debug(`get client.user.activate ${this.sock.id}, user_id: ${this.user_id}`),this.is_active=!0},Client.prototype.onClientDeactivate=function(){logger.debug(`get client.user.deactivate ${this.sock.id}, user_id: ${this.user_id}`),this.is_active=!1},Client.prototype.onClientTyping=function(t){logger.debug(`get client.user.typing ${this.sock.id}:${t}`),this.typing={timeout:new Date((new Date).valueOf()+1e4),thread_id:t},this.cur_channel_id&&this.service.updateTyping(this.cur_channel_id)},Client.prototype.onClientClearTyping=function(){logger.debug(`get client.user.clear_typing ${this.sock.id}`),this.typing=null,this.cur_channel_id&&this.service.updateTyping(this.cur_channel_id)},Client.prototype.isMobile=function(){return"mobile"===this.user_client},Client.prototype.isActive=function(){return this.is_active},Client.prototype.updateUserStatus=function(t){return this.api.setUserStatus(this.sock,{user_id:this.user_id,status:t})},Client.prototype.addDestoryCallback=function(t){this.destory_callbacks.push(t)},Client.prototype.enterChannel=function(t){this.cur_channel_id!==t&&(null!==this.cur_channel_id&&this.leaveChannel(),this.cur_channel_id=t,this.sock.leave(room.getRoomByOfflineChannel(this.cur_channel_id)),this.sock.join(room.getRoomByChannel(this.cur_channel_id)))},Client.prototype.leaveChannel=function(){null!==this.cur_channel_id&&(this.sock.leave(room.getRoomByChannel(this.cur_channel_id)),this.sock.join(room.getRoomByOfflineChannel(this.cur_channel_id)),this.cur_channel_id=null)},Client.prototype.joinChannel=function(t){this.sock.join(room.getRoomByOfflineChannel(t))},Client.prototype.disjoinChannel=function(t){this.cur_channel_id===t&&(this.sock.leave(room.getRoomByChannel(this.cur_channel_id)),this.cur_channel_id=null),this.sock.leave(room.getRoomByOfflineChannel(t))},Client.prototype.sendPost=function(t){this.sock.broadcast.to(room.getRoomByChannel(t.channel_id)).emit("client.post.create",{user_id:this.user_id,channel_id:t.channel_id,data:t}),this.sock.broadcast.to(room.getRoomByOfflineChannel(t.channel_id)).emit("client.post.create",{user_id:this.user_id,channel_id:t.channel_id,data:{creator_id:(t||{}).creator_id,create_at:(t||{}).create_at,mentions:(t||{}).mentions,post_id:(t||{}).post_id,thread_id:(t||{}).thread_id,type:(t.data||{}).type,system_props:(t.data||{}).system_props}})},Client.prototype.updateKey=function(t){this.sock.broadcast.to(room.getRoomByUser(t.user_id)).emit("client.user.updatekey",t)},Client.prototype.broadcastUser=function(t){(t.user_ids||[]).forEach(e=>{this.sock.broadcast.to(room.getRoomByUser(e)).emit("client.broadcast",{type:t.type,data:t.data})})},Client.prototype.broadcastChannel=function(t){switch(t.broadcast_type){case"all":this.sock.broadcast.to(room.getRoomByChannel(t.channel_id)).emit("client.broadcast",{type:t.type,data:t.data}),this.sock.broadcast.to(room.getRoomByOfflineChannel(t.channel_id)).emit("client.broadcast",{type:t.type,data:t.data});break;case"joinonly":this.sock.broadcast.to(room.getRoomByOfflineChannel(t.channel_id)).emit("client.broadcast",{type:t.type,data:t.data});break;case"enter":this.sock.broadcast.to(room.getRoomByChannel(t.channel_id)).emit("client.broadcast",{type:t.type,data:t.data});break;default:logger.error(`broadcast channel unknown type ${JSON.stringify(t)}`)}},Client.prototype.broadcastRoom=function(t,e){this.sock.broadcast.to(t).emit("client.broadcast",{type:e.type,data:e.data})},Client.prototype.broadcastAll=function(t){this.sock.broadcast.emit("client.broadcast",{type:t.type,data:t.data})},Client.prototype.destroy=function(){var t=Promise.resolve();this.service.isClosing||(this.typing=null,this.cur_channel_id&&this.service.updateTyping(this.cur_channel_id),this.service.isUserOffline(this.user_id)&&(t=t.then(()=>this.updateUserStatus("offline"))),this.integration&&this.service.isUserIntegrationOffline(this.integration)&&this.service.updateIntegrationOnline(this.integration)),t=t.then(()=>this.destory_callbacks.forEach(t=>t.call(this)))},module.exports=Client;