/* Copyright (c) 2000-2017 Synology Inc. All rights reserved. */
"use strict";var EventEmitter=require("events").EventEmitter,helper=require("../helper"),logger=require("../logger"),Service=helper.utils.extend(EventEmitter,function(e,t){EventEmitter.call(this),this.io=e,this.api=t,this.isClosing=!1,this.on("chat.channel.enter",this.onEnterChannel.bind(this)),this.on("chat.channel.leave",this.onLeaveChannel.bind(this)),this.on("chat.channel.join",this.onJoinChannel.bind(this)),this.on("chat.channel.disjoin",this.onDisjoinChannel.bind(this)),this.on("chat.channel.close",this.onCloseChannel.bind(this)),this.on("chat.post.create",this.onSendPost.bind(this)),this.on("chat.user.update_key",this.onUpdateKey.bind(this)),this.on("chat.broadcast.user",this.onBroadcastUser.bind(this)),this.on("chat.broadcast.channel",this.onBroadcastChannel.bind(this)),this.on("chat.broadcast.all",this.onBroadcastAll.bind(this)),this.api.clearUserStatus()});Service.prototype.getClient=function(e){return(this.io.sockets.connected[e]||{}).chat},Service.prototype.getClients=function(e){var t=this.io.sockets.adapter.rooms[helper.room.getRoomByUser(e)];return t?Object.keys(t.sockets).map(this.getClient.bind(this)).filter(e=>e):[]},Service.prototype.getClientsInChannel=function(e){var t=this.io.sockets.adapter.rooms[helper.room.getRoomByChannel(e)],n=this.io.sockets.adapter.rooms[helper.room.getRoomByOfflineChannel(e)],o=[];return t&&(o=o.concat(Object.keys(t.sockets))),n&&(o=o.concat(Object.keys(n.sockets))),o.map(this.getClient.bind(this)).filter(e=>e)},Service.prototype.getClientsEntered=function(e){var t=this.io.sockets.adapter.rooms[helper.room.getRoomByChannel(e)];return t?Object.keys(t.sockets).map(this.getClient.bind(this)).filter(e=>e):[]},Service.prototype.getIntegrationOnline=function(e){var t=this.io.sockets.adapter.rooms[helper.room.getRoomByIntegration(e)];return t?Object.keys(t.sockets).map(this.getClient.bind(this)).reduce(function(e,t){return t&&-1===e.indexOf(t.user_id)&&e.push(t.user_id),e},[]):[]},Service.prototype.updateIntegrationOnline=function(e){var t=this.getIntegrationOnline(e);this.io.to(helper.room.getRoomByIntegration(e)).emit("client.integration.online",{user_ids:t})},Service.prototype.isUserOffline=function(e){return!this.io.sockets.adapter.rooms[helper.room.getRoomByUser(e)]},Service.prototype.isUserIntegrationOffline=function(e,t){var n=this.io.sockets.adapter.rooms[helper.room.getRoomByIntegration(e)];return!n||!Object.keys(n.sockets).find(e=>(this.getClient(e)||{}).user_id===t)},Service.prototype.getExceptUserRooms=function(e){var t=e.reduce((e,t)=>(e[helper.room.getRoomByUser(t)]=!0)&&e,{});return Object.keys(this.io.sockets.adapter.rooms).filter(e=>helper.room.isUserRoom(e)&&!t[e])},Service.prototype.getTypingStates=function(e){var t=new Date,n=this.getClientsEntered(e).reduce(function(e,n){return null!==n.typing&&n.typing.timeout>t&&(e[n.typing.thread_id]=e[n.typing.thread_id]||[]).push(n.user_id),e},{});return n.channel_id=e,n},Service.prototype.updateTyping=function(e){this.io.to(helper.room.getRoomByChannel(e)).emit("client.channel.typing_v2",this.getTypingStates(e))},Service.prototype.onUpdateKey=function(e){var t=this.getClient(e.conn_id);t?t.updateKey(e):this.io.to(helper.room.getRoomByUser(e.user_id)).emit("client.user.updatekey",e),void 0!==e.public_key&&this.getExceptUserRooms([e.user_id]).forEach(t=>this.io.to(t).emit("client.user.updatekey",{user_id:e.user_id,public_key:e.public_key})),e.channels&&e.channels.forEach(function(t){t.channel_key_enc||(this.io.to(helper.room.getRoomByChannel(t.channel_id)).emit("client.channel.brokenuser",{channel_id:t.channel_id,user_id:e.user_id}),this.io.to(helper.room.getRoomByOfflineChannel(t.channel_id)).emit("client.channel.brokenuser",{channel_id:t.channel_id,user_id:e.user_id}))}.bind(this))},Service.prototype.onEnterChannel=function(e){var t=this.getClient(e.conn_id);t&&t.enterChannel(e.channel_id)},Service.prototype.onLeaveChannel=function(e){var t=this.getClient(e.conn_id);t&&t.leaveChannel()},Service.prototype.onJoinChannel=function(e){this.getClients(e.user_id).forEach(function(t){t.joinChannel(e.channel_id)}),this.io.to(helper.room.getRoomByChannel(e.channel_id)).emit("client.channel.join",e),this.io.to(helper.room.getRoomByOfflineChannel(e.channel_id)).emit("client.channel.join",e)},Service.prototype.onDisjoinChannel=function(e){this.getClients(e.user_id).forEach(t=>t.disjoinChannel(e.channel_id)),this.io.to(helper.room.getRoomByUser(e.user_id)).emit("client.channel.disjoin",e),this.io.to(helper.room.getRoomByChannel(e.channel_id)).emit("client.channel.disjoin",e),this.io.to(helper.room.getRoomByOfflineChannel(e.channel_id)).emit("client.channel.disjoin",e)},Service.prototype.onCloseChannel=function(e){var t=e.channel.channel_id,n="client.channel.close";("CHANNEL_CLOSE_TYPE_HIDE_GLOBAL"===e.channel_close_type?(n="client.channel.hide_global",e.channel_id=e.channel.channel_id,delete e.channel):"CHANNEL_CLOSE_TYPE_FAKE_CLOSE"===e.channel_close_type||"CHANNEL_CLOSE_TYPE_REAL_CLOSE"===e.channel_close_type?n="client.channel.close":"CHANNEL_CLOSE_TYPE_UNHIDE_GLOBAL"===e.channel_close_type&&(n="client.channel.unhide_global",e.channel_id=e.channel.channel_id,delete e.channel),this.io.to(helper.room.getRoomByChannel(t)).emit(n,e),this.io.to(helper.room.getRoomByOfflineChannel(t)).emit(n,e),"CHANNEL_CLOSE_TYPE_HIDE_GLOBAL"!==e.channel_close_type&&"CHANNEL_CLOSE_TYPE_UNHIDE_GLOBAL"!==e.channel_close_type)&&this.getClientsInChannel(t).forEach(e=>e.disjoinChannel(t))},Service.prototype.onSendPost=function(e){var t=this.getClient(e.conn_id);t?t.sendPost(e.data):this.onChannelSendPost(e)},Service.prototype.onChannelSendPost=function(e){e=e||{},this.io.to(helper.room.getRoomByChannel(e.channel_id)).emit("client.post.create",{channel_id:e.channel_id,user_id:(e.data||{}).creator_id,data:e.data}),this.io.to(helper.room.getRoomByOfflineChannel(e.channel_id)).emit("client.post.create",{channel_id:e.channel_id,user_id:(e.data||{}).creator_id,data:{creator_id:(e.data||{}).creator_id,create_at:(e.data||{}).create_at,mentions:(e.data||{}).mentions,post_id:(e.data||{}).post_id,thread_id:(e.data||{}).thread_id,type:(e.data||{}).type,system_props:(e.data||{}).system_props}})},Service.prototype.onBroadcastUser=function(e){if(void 0!==e.conn_id){var t=this.getClient(e.conn_id);if(t)return void t.broadcastUser(e);logger.error(`broadcast user cannot find client ${JSON.stringify(e)}`)}(e.user_ids||[]).forEach(t=>{this.io.to(helper.room.getRoomByUser(t)).emit("client.broadcast",{type:e.type,data:e.data})})},Service.prototype.onBroadcastChannel=function(e){if(void 0!==e.conn_id){var t=this.getClient(e.conn_id);if(t)return void t.broadcastChannel(e);logger.error(`broadcast channel cannot find client ${JSON.stringify(e)}`)}switch(e.broadcast_type){case"all":this.io.to(helper.room.getRoomByChannel(e.channel_id)).emit("client.broadcast",{type:e.type,data:e.data}),this.io.to(helper.room.getRoomByOfflineChannel(e.channel_id)).emit("client.broadcast",{type:e.type,data:e.data});break;case"joinonly":this.io.to(helper.room.getRoomByOfflineChannel(e.channel_id)).emit("client.broadcast",{type:e.type,data:e.data});break;case"enter":this.io.to(helper.room.getRoomByChannel(e.channel_id)).emit("client.broadcast",{type:e.type,data:e.data});break;default:logger.error(`broadcast channel unknown type ${JSON.stringify(e)}`)}},Service.prototype.onBroadcastAll=function(e){var t;void 0!==e.conn_id&&((t=this.getClient(e.conn_id))||logger.error(`broadcast channel cannot find client ${JSON.stringify(e)}`)),void 0===e.except_user_ids?t?t.broadcastAll(e):this.io.sockets.emit("client.broadcast",{type:e.type,data:e.data}):this.getExceptUserRooms(e.except_user_ids).forEach(n=>{t?t.broadcastRoom(n,e):this.io.to(n).emit("client.broadcast",{type:e.type,data:e.data})})},Service.prototype.close=function(){this.isClosing=!0;var e=this.io.sockets.sockets;Promise.all(Object.keys(e).map(function(t){return new Promise(function(n,o){e[t].chat.addDestoryCallback(n)})})).then(()=>this.emit("close")),this.io.close()},Service.prototype.destroy=function(){this.removeAllListeners()},module.exports=Service;