/* Copyright (c) 2000-2017 Synology Inc. All rights reserved. */
"use strict";var assert=require("assert"),http=require("http"),ChatService=require("../../chat_service"),ConnectQueue=require("../../chat_service/connect_queue"),net=require("net"),ioClient=require("socket.io-client"),ioServer=require("socket.io"),MocChatAPIRunner=require("../../chat_service/moc_runner"),ChatAPI=require("../../chat_service/chat_api"),room=require("../../helper/room"),PORT=55666,URL="http://localhost:"+PORT;describe("ChatService",function(){var e=null,t=null,n=null,o=null,i=null,c=null;beforeEach("setup service",function(){o=new MocChatAPIRunner,i=new ChatAPI(o,o),n=new ConnectQueue,e=http.createServer(),c=ioServer(e),t=ChatService(c,n,i),e.listen(PORT)}),afterEach("clear service",function(){e.close(),e=null,n.clear(),n=null,o=null,i=null,c=null,t.removeAllListeners(),t=null}),describe("#auth",function(){it("should init version",function(e){var t,n=ioClient(URL+"?SynoToken=0",{forceNew:!0});new Promise(function(e,o){n.on("client.init",function(n){t=n.version,e()})}).then(function(){assert.equal(process.env.npm_package_version,t),n.disconnect(),e()}).catch(t=>e(t.stack||t))}),it("should init socket room",function(e){var t,n=ioClient(URL+"?SynoToken=0",{forceNew:!0});new Promise(function(e,o){n.on("client.init",function(n){t=n.id,e()})}).then(function(){var o=c.sockets.connected[t],i=Object.keys(o.rooms);assert.ok(o),assert.equal(i.length,3),assert.notEqual(i.indexOf(t),-1),assert.notEqual(i.indexOf(room.getRoomByOfflineChannel(0),-1)),assert.notEqual(i.indexOf(room.getRoomByUser(0),-1)),n.disconnect(),e()}).catch(t=>e(t.stack||t))}),it("should set socket type",function(e){var n,o=ioClient(URL+"?SynoToken=0&client=mobile",{forceNew:!0});new Promise(function(e,t){o.on("client.init",function(t){n=t.id,e()})}).then(function(){assert.ok(t.getClient(n).isMobile()),o.disconnect(),e()}).catch(t=>e(t.stack||t))}),it("should set socket integration",function(e){var n,o=ioClient(URL+'?SynoToken=0&integration={"app":"chat","key":"1"}',{forceNew:!0});new Promise(function(e,t){o.on("client.init",function(t){n=t.id,e()})}).then(function(){assert.deepEqual({app:"chat",key:"1"},t.getClient(n).integration),o.disconnect(),e()}).catch(t=>e(t.stack||t))}),it("should update user status",function(e){o.apis.forEach(function(n){if("SYNO.Chat.User.Status"===n.api&&"set"===n.method&&1===n.version){var o=n.handler;n.handler=function(i){assert.equal(i.params.status,"online"),n.handler=o,t.disconnect(),e()}}});var t=ioClient(URL+"?SynoToken=0",{forceNew:!0})})}),describe("#queue",function(){it("should delay login",function(e){n.clear(),n.throttle=1,n.timeoutMS=3e3,this.timeout(n.timeoutMS+1e3);var t=!1,o=ioClient(URL+"?SynoToken=0",{forceNew:!0});setTimeout(()=>t=!0,n.timeoutMS-500);var i=ioClient(URL+"?SynoToken=0",{forceNew:!0});new Promise((e,t)=>{i.on("client.init",e)}).then(()=>{assert.ok(t),o.disconnect(),i.disconnect(),n.throttle=1/0,n.timeoutMS=0,e()}).catch(t=>e(t.stack||t))}),it("should delay login with return initdone",function(e){n.clear(),n.throttle=1,n.timeoutMS=3e3,this.timeout(n.timeoutMS+1e3);var t=!1,o=ioClient(URL+"?SynoToken=0",{forceNew:!0}),i=setTimeout(()=>t=!0,n.timeoutMS-500),c=ioClient(URL+"?SynoToken=0",{forceNew:!0});o.on("client.init",()=>o.emit("client.initdone")),new Promise((e,t)=>{c.on("client.init",e)}).then(()=>{assert.ok(!t),clearTimeout(i),o.disconnect(),c.disconnect(),n.throttle=1/0,n.timeoutMS=0,e()}).catch(t=>e(t.stack||t))}),it("should handle disconnect",function(e){n.clear(),n.throttle=1,n.timeoutMS=3e3,this.timeout(n.timeoutMS+1e3);var t=!1,o=ioClient(URL+"?SynoToken=0",{forceNew:!0}),i=setTimeout(()=>t=!0,n.timeoutMS-500);setTimeout(()=>o.disconnect(),n.timeoutMS-2e3);var c=ioClient(URL+"?SynoToken=0",{forceNew:!0});new Promise((e,t)=>{c.on("client.init",e)}).then(()=>{assert.ok(!t),clearTimeout(i),o.disconnect(),c.disconnect(),n.throttle=1/0,n.timeoutMS=0,e()}).catch(t=>e(t.stack||t))}),it("should handle disconnect attack",function(e){o.config.delay=20,n.clear(),n.throttle=1,n.timeoutMS=3e3,this.timeout(n.timeoutMS+1e3);var t=!1,i=ioClient(URL+"?SynoToken=0",{forceNew:!0});setTimeout(()=>i.disconnect(),10);var c=setTimeout(()=>t=!0,n.timeoutMS-500),r=ioClient(URL+"?SynoToken=0",{forceNew:!0});new Promise((e,t)=>{r.on("client.init",e)}).then(()=>{assert.ok(!t),clearTimeout(c),r.disconnect(),n.throttle=1/0,n.timeoutMS=0,o.config.delay=0,e()}).catch(t=>e(t.stack||t))})}),describe("#disconnect",function(){it("should update user status",function(e){o.apis.forEach(function(t){if("SYNO.Chat.User.Status"===t.api&&"set"===t.method&&1===t.version){var n=t.handler;t.handler=function(o){assert.equal(o.params.status,"offline"),t.handler=n,e()}}});var t=ioClient(URL+"?SynoToken=0",{forceNew:!0});t.on("client.init",()=>t.disconnect())})})});