/* Copyright (c) 2000-2017 Synology Inc. All rights reserved. */
"use strict";var assert=require("assert"),TestCtx=require("./test_ctx"),ioClient=require("socket.io-client"),room=require("../../helper/room");describe("ChatService Broadcast",function(){var t;beforeEach("setup service",e=>t=new TestCtx(e)),afterEach("clear service",function(){t.destroy(),t=null}),describe("#broadcastAll",function(){var e;beforeEach(function(a){t.sock.listeners("client.broadcast").forEach(t=>sock.removeListener("client.broadcast",t)),(e=ioClient(t.URL+"?SynoToken=1",{forceNew:!0})).on("client.init",()=>a())}),afterEach(function(){e.disconnect(),e=null}),it("should send to all",function(a){Promise.all([new Promise(function(e,a){t.sock.on("client.broadcast",function(t){assert.equal(!0,t.data),e()})}),new Promise(function(t,a){e.on("client.broadcast",function(e){assert.equal(!0,e.data),t()})})]).then(()=>a()).catch(t=>a(t.stack||t)),t.chatService.emit("chat.broadcast.all",{data:!0})}),it("should not send to self",function(a){t.sock.on("client.broadcast",()=>assert.equal(!0,!1)),e.on("client.broadcast",function(t){assert.equal(!0,t.data),setTimeout(()=>a(),50)}),t.chatService.emit("chat.broadcast.all",{conn_id:t.id,data:!0})}),it("should not send to except user",function(a){t.sock.on("client.broadcast",()=>assert.equal(!0,!1)),e.on("client.broadcast",function(t){assert.equal(!0,t.data),setTimeout(()=>a(),50)}),t.chatService.emit("chat.broadcast.all",{except_user_ids:[0],data:!0})}),it("should not send to except user and self",function(a){t.sock.on("client.broadcast",()=>assert.equal(!0,!1)),e.on("client.broadcast",()=>assert.equal(!0,!1)),t.chatService.emit("chat.broadcast.all",{except_user_ids:[1],conn_id:t.id,data:!0}),setTimeout(()=>a(),50)})}),describe("#broadcastUser",function(){var e;beforeEach(function(a){t.sock.listeners("client.broadcast").forEach(t=>sock.removeListener("client.broadcast",t)),(e=ioClient(t.URL+"?SynoToken=0",{forceNew:!0})).on("client.init",()=>a())}),afterEach(function(){e.disconnect(),e=null}),it("should send to all",function(a){Promise.all([new Promise(function(e,a){t.sock.on("client.broadcast",function(t){assert.equal(!0,t.data),e()})}),new Promise(function(t,a){e.on("client.broadcast",function(e){assert.equal(!0,e.data),t()})})]).then(()=>a()).catch(t=>a(t.stack||t)),t.chatService.emit("chat.broadcast.user",{user_ids:[0],data:!0})}),it("should not send to self",function(a){t.sock.on("client.broadcast",()=>assert.equal(!0,!1)),e.on("client.broadcast",function(t){assert.equal(!0,t.data),setTimeout(()=>a(),50)}),t.chatService.emit("chat.broadcast.user",{user_ids:[0],conn_id:t.id,data:!0})})}),describe("#broadcastChannel",function(){var e;beforeEach(function(a){t.sock.listeners("client.broadcast").forEach(t=>sock.removeListener("client.broadcast",t)),(e=ioClient(t.URL+"?SynoToken=0",{forceNew:!0})).on("client.init",function(e){t.chatService.emit("chat.channel.enter",{conn_id:e.id,channel_id:0}),a()})}),afterEach(function(){e.disconnect(),e=null}),it("should send to all",function(a){Promise.all([new Promise(function(e,a){t.sock.on("client.broadcast",function(t){assert.equal(!0,t.data),e()})}),new Promise(function(t,a){e.on("client.broadcast",function(e){assert.equal(!0,e.data),t()})})]).then(()=>a()).catch(t=>a(t.stack||t)),t.chatService.emit("chat.broadcast.channel",{broadcast_type:"all",channel_id:0,data:!0})}),it("should send to who is in room",function(a){t.sock.on("client.broadcast",()=>assert.equal(!0,!1)),e.on("client.broadcast",function(t){assert.equal(!0,t.data),setTimeout(()=>a(),50)}),t.chatService.emit("chat.broadcast.channel",{broadcast_type:"enter",channel_id:0,data:!0})}),it("should send to who not in room",function(a){t.sock.on("client.broadcast",function(t){assert.equal(!0,t.data),setTimeout(()=>a(),50)}),e.on("client.broadcast",()=>assert.equal(!0,!1)),t.chatService.emit("chat.broadcast.channel",{broadcast_type:"joinonly",channel_id:0,data:!0})}),it("should not send to self",function(a){t.sock.on("client.broadcast",()=>assert.equal(!0,!1)),e.on("client.broadcast",function(t){assert.equal(!0,t.data),setTimeout(()=>a(),50)}),t.chatService.emit("chat.broadcast.channel",{conn_id:t.id,broadcast_type:"all",channel_id:0,data:!0})}),it("should not send because of unknown type",function(a){t.sock.on("client.broadcast",()=>assert.equal(!0,!1)),e.on("client.broadcast",()=>assert.equal(!0,!1)),t.chatService.emit("chat.broadcast.channel",{broadcast_type:"gg",channel_id:0,data:!0}),setTimeout(()=>a(),50)})})});