/* Copyright (c) 2000-2016 Synology Inc. All rights reserved. */
"use strict";var exec=require("./exec"),config=require("./config"),fs=require("fs"),https=require("https"),User=require("./user"),Channel=require("./channel"),logger=require("../logger"),path=require("path"),Parser=function(){this._fd=null};Parser.prototype.parse=function(){return Promise.resolve().then(()=>this.setupWorkingDir()).then(()=>this.openExport()).then(()=>this.parseSlack()).then(()=>this.closeExport()).catch(r=>logger.error(`error: ${r.toSring()}`))},Parser.prototype.setupWorkingDir=function(){return logger.debug("setup working dir"),Promise.resolve().then(()=>this.cleanWorkingDir()).then(()=>exec("/bin/mkdir",["-p",`${config.workingDir}/.out/file`])).then(()=>exec("/bin/mkdir",["-p",`${config.workingDir}/.out/avatar`])).then(()=>exec("/bin/7z",["x","-p''",`-o${config.workingDir}`,config.source]))},Parser.prototype.openExport=function(){return logger.debug("open export"),new Promise((r,e)=>{fs.open(`${config.workingDir}/.out/export.json`,"w",(o,n)=>{if(o)return logger.error(`open file fail: ${config.workingDir}/.out/export.json`),logger.error(o.toString()),void e(o);this._fd=n,r()})})},Parser.prototype.closeExport=function(){return logger.debug("close export"),new Promise((r,e)=>{fs.close(this._fd,o=>{if(o)return logger.error(`close file fail: ${config.workingDir}/.out/export.json`),logger.error(o.toString()),void e(o);this._fd=null,r()})})},Parser.prototype.parseSlack=function(){return logger.debug("parsing"),Promise.resolve().then(()=>User.read()).then(()=>Channel.read()).then(()=>User.genCreateIR(this)).then(()=>Channel.genCreateIR(this)).then(()=>Channel.genMsgIR(this)).then(()=>Channel.genPinIR(this)).then(()=>User.genDeleteIR(this))},Parser.prototype.writeExport=function(r){return new Promise((e,o)=>{fs.write(this._fd,r,(r,n,t)=>{if(r)return logger.error(`append file fail: ${n}, ${t}`),logger.error(r.toString()),void o(r);e()})})},Parser.prototype.downloadAsset=function(r,e,o){return logger.debug(`download asset: ${r}`),new Promise((n,t)=>{var i=fs.createWriteStream(`${config.workingDir}/.out/${o}/${e}`),g=https.get(r,r=>{r.pipe(i),i.on("finish",()=>i.close(n))});i.on("error",t),g.on("error",t)})},Parser.prototype.logger=function(r,e,o){return e=e||0,o=o||0,new Promise((n,t)=>{fs.writeFile("/run/synochat/import_progress",`${r} ${e} ${o}`,(r,e,o)=>{r&&(logger.error(`append file fail: ${e}, ${o}`),logger.error(r.toString())),n()})})},Parser.prototype.zipResult=function(){return logger.debug("zip target"),exec("/bin/bash",["-c",`cd ${config.workingDir}/.out; 7z a ${path.resolve(__dirname,config.target)} *`])},Parser.prototype.cleanWorkingDir=function(){return logger.debug("clean working dir"),Promise.resolve().then(()=>exec("/bin/rm",["-rf",config.workingDir]))},module.exports=Parser;